<?php

// Configuration

	// Behavioral settings:

	 define('SESAAME_REQUIRE_VERIFICATION',FALSE);
	 define('SESAAME_KEEP_INVITES',TRUE);
	 define('SESAAME_REMOVE_REFS',FALSE);

	// The messages that appear on each page:

	 define('SESAAME_GREETING_HOME','Welcome to the Sesaame Demonstration.');
	 define('SESAAME_GREETING_JOIN','To join the invite system, all you need to do is enter your email address in the form below.');
	 define('SESAAME_GREETING_INVITE','Please complete the form below with your email address and a friend\'s email address.');
	 define('SESAAME_GREETING_INFO','Send invitations to let your friends know about this site.  When your friends join from your invitation, you will receive credits toward your goal.  To check how many credits you\'ve earned, use the form below.');
	 define('SESAAME_GREETING_REFS','You have received %refs% referral credits.');
	 define('SESAAME_GREETING_REMOVE','We\'re sorry to see you go.  To be removed from our database just enter your registered email address below.');

	// Confirmation and error messages for response to actions:

	 define('SESAAME_SUCCESS_SIGNUP','Thanks for signing up!  A message has been sent to your email address with a link you must follow in order to activate your account.');
	 define('SESAAME_SUCCESS_JOIN','Thanks for joining!  You can start sending invites right away.');
	 define('SESAAME_SUCCESS_INVITE','Your invitation was sent.  You will receive credit when your friend joins from your invitation.  How about sending another invitation?');
	 define('SESAAME_SUCCESS_REMOVE','We have processed your removal.');

	 define('SESAAME_ERROR_INVALID_EMAIL','The email you entered was invalid -- please try again.');
	 define('SESAAME_ERROR_ALREADY_MEMBER','That email address already exists in our database.');
	 define('SESAAME_ERROR_NOT_MEMBER','You must be a member to do that! It\'s okay, it\'s easy to join.');

	// Email texts

	 define('SESAAME_INVITE_SUBJECT','%from% has invited you to the Sesaame Demo.');
	 define('SESAAME_INVITE_MESSAGE','Check out what Sesaame has to offer. Join immediately by clicking <a href="%url%">here</a>. Or copy and paste the following URL into your browser\'s address bar: %url%');

	 define('SESAAME_VERIFICATION_FROM','account@site.com');
	 define('SESAAME_VERIFICATION_SUBJECT','Please verify your email for Sesaame Demo');
	 define('SESAAME_VERIFICATION_MESSAGE','Please click <a href="%url%">here</a> to verify your email address and activate your account. Or copy and paste the following URL into your browser\'s address bar: %url%');


// Interface

	function sesaame_greeting($message)
	{
		print "\t<div id=\"sesaame_greeting\">\n\t\t{$message}\n\t</div>\n";
	}

	function sesaame_error($message)
	{
		print "\t<div id=\"sesaame_error\">\n\t\t{$message}\n\t</div>\n";
	}

	function sesaame_nav()
	{
		print "\t<div id=\"sesaame_nav\">\n";

		if($_REQUEST['action'])
			print "\t\t<a href=\"?\">Home</a>\n";
		if(empty($_REQUEST['email']) && strcmp($_REQUEST['action'],'join'))
			print "\t\t<a href=\"?action=join\">Join</a>\n";
		if(strcmp($_REQUEST['action'],'invite'))
			print "\t\t<a href=\"?action=invite\">Invite</a>\n";
		print "\t\t<a href=\"?action=info\">Info</a>\n";

		print "\t</div>\n";
	}

	function sesaame_form_remove()
	{
		print "\t<form action=\"?action=remove\" method=\"post\">\n\t\t<input name=\"email\" type=\"text\" value=\"Your email address\">\n\t\t<input type=\"submit\" value=\"Submit &raquo;\">\n\t</form>\n";
	}

	function sesaame_form_info()
	{
		print "\t<form action=\"?action=info\" method=\"post\">\n\t\t<input name=\"email\" type=\"text\" value=\"Your email address\">\n\t\t<input type=\"submit\" value=\"Submit &raquo;\">\n\t</form>\n";
	}

	function sesaame_form_invite()
	{
		print "\t<form action=\"?action=invite\" method=\"post\">\n\t\t<input name=\"email\" type=\"text\" value=\"";
		if(empty($_REQUEST['email']))
			print 'Your email address';
		else
			print $_REQUEST['email'];
		print "\">\n\t\t<input name=\"friend\" type=\"text\" value=\"Friend's email address\">\n\t\t<input type=\"submit\" value=\"Submit &raquo;\">\n\t</form>\n";
	}

	function sesaame_form_join()
	{
		print "\t<form action=\"?action=join\" method=\"post\">\n\t\t<input name=\"email\" type=\"text\" value=\"Enter email address\">\n\t\t<input type=\"submit\" value=\"Submit &raquo;\">\n\t</form>\n";
	}

// Utility

	function sesaame_send_invite_email($id)
	{
		$os = strtolower(substr(php_uname('s'),0,3));
		if($os=='win') $newline = "\n";
		else $newline = "\r\n";

		$from = $_REQUEST['email'];
		$to = $_REQUEST['friend'];
		$subject = str_replace('%from%',$from,SESAAME_INVITE_SUBJECT);
		$subject = str_replace('%to%',$to,$subject);
		$message = str_replace('%url%',"http://localhost:82/sesaame/?action=verify&id={$id}",SESAAME_INVITE_MESSAGE);
		$headers = "From: {$from}{$newline}Reply-To: {$from}{$newline}";

		$success = mail($to,$subject,$message,$headers);
	}

	function sesaame_send_verification_email($id)
	{
		$os = strtolower(substr(php_uname('s'),0,3));
		if($os=='win') $newline = "\n";
		else $newline = "\r\n";

		$from = SESAAME_VERIFICATION_FROM;
		$to = $_REQUEST['friend'];
		$subject = str_replace('%from%',$from,SESAAME_VERIFICATION_SUBJECT);
		$subject = str_replace('%to%',$to,$subject);
		$message = str_replace('%url%',"http://localhost:82/sesaame/?action=verify&id={$id}",SESAAME_VERIFICATION_MESSAGE);
		$headers = "From: {$from}{$newline}Reply-To: {$from}{$newline}";

		$success = mail($to,$subject,$message,$headers);
	}

	function sesaame_valid_email($email)
	{
		if(substr_count($email,'@') != 1)
			return 0;

		$atpos = strpos($email,'@');
		if(($atpos == 0) || ($atpos >= (strlen($email)-4)))
			return 0;

		$part1 = substr($email,0,$atpos);
		$part2 = substr($email,$atpos+1,strlen($email)-strlen($part1)-1);

		if(!substr_count($part2,'.'))
			return 0;

		if(strspn($email,'_.-@+0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ') != strlen($email))
			return 0;
		return 1;
	}

// Database

	function sesaame_dbcheck()
	{
		if(!is_dir('data'))
		{
			mkdir('data');
			$file = fopen('keys/.htaccess','w');
			fwrite($file,"Order allow,deny\nDeny from all");
			fclose($file);
		}
		if(!file_exists('data/list.txt')) fclose(fopen('data/list.txt','a'));
		if(!file_exists('data/refs.txt')) fclose(fopen('data/refs.txt','a'));
		if(!file_exists('data/invites.txt')) fclose(fopen('data/invites.txt','a'));
	}

	function sesaame_listed($email)
	{
		sesaame_dbcheck();
		$file = file('data/list.txt');
		foreach($file as $listing)
			if(!strcasecmp($email,trim($listing))) return 1;
		return 0;
	}

	function sesaame_refs($email)
	{
		sesaame_dbcheck();
		$file = file('data/refs.txt');
		foreach($file as $data)
		{
			$parts = explode(' ',trim($data));
			if(!strcasecmp($email,$parts[0]))
				return (int) $parts[1];
		}
		return 0;
	}

	function sesaame_credit($email)
	{
		sesaame_dbcheck();
		$file = file('data/refs.txt');
		foreach($file as &$data)
		{
			$parts = explode(' ',trim($data));

			if(!strcasecmp($email,$parts[0]))
			{
				$a = $parts[1]+1;
				$data = "{$email} {$a}\r\n";
			}
		}
		file_put_contents('data/refs.txt',$file);
	}

	function sesaame_new_invite()
	{
		sesaame_dbcheck();
		$id = uniqid();
		file_put_contents('data/invites.txt', "{$id} {$_REQUEST['friend']} {$_REQUEST['email']}\r\n",FILE_APPEND);		
		return $id;
	}

	function sesaame_new_member()
	{
		sesaame_dbcheck();
		file_put_contents('data/list.txt', "{$_REQUEST['email']}\r\n",FILE_APPEND);
		file_put_contents('data/refs.txt', "{$_REQUEST['email']} 0\r\n",FILE_APPEND);
	}

	function sesaame_remove($e)
	{
		$f = file('data/list.txt');
		foreach($f as &$l)
		{
			$l = trim($l);
			if(!strcasecmp($l,$e))
				$l = '';
			else $l = "{$l}\r\n";
		}
		file_put_contents('data/list.txt',$f);

		if(SESAAME_REMOVE_REFS)
		{
			$f = file('data/refs.txt');
			foreach($f as &$l)
			{
				$l = trim($l);
				$p = explode(' ',$l);
				if(!strcasecmp($p[0],$e))
					$l = '';
				else $l = "{$l}\r\n";
			}
			file_put_contents('data/refs.txt',$f);
		}
		sesaame_greeting(SESAAME_SUCCESS_REMOVE);
	}

// Action

	function sesaame_verify()
	{
		sesaame_dbcheck();
		$file = file('data/invites.txt');
		foreach($file as &$listing)
		{
			$parts = explode(' ',trim($listing));
			if($parts[0]==$_REQUEST['id'])
			{
				if(sesaame_listed($parts[1]))
				{
					sesaame_error(SESAAME_ERROR_ALREADY_MEMBER);
				}
				else
				{
					if(!sesaame_valid_email($parts[1]))
					{
						sesaame_error(SESAAME_ERROR_INVALID_EMAIL);
					}
					else
					{
						$_REQUEST['email'] = $parts[1];
						sesaame_new_member();
						sesaame_greeting(SESAAME_SUCCESS_JOIN);
						sesaame_credit($parts[2]);
					}
				}
				$listing = '';
			}
		}
		if(!SESAAME_KEEP_INVITES) file_put_contents('data/invites.txt',$file);
	}

	function sesaame_invite()
	{
		if(!sesaame_valid_email($_REQUEST['email']) || !sesaame_valid_email($_REQUEST['friend']))
		{
			sesaame_error(SESAAME_ERROR_INVALID_EMAIL);
			sesaame_form_invite();
		}
		else
		{
			if(!sesaame_listed($_REQUEST['email']))
			{
				sesaame_error(SESAAME_ERROR_NOT_MEMBER);
				$_REQUEST['email'] = '';
				sesaame_form_invite();
			}
			else
			{
				if(sesaame_listed($_REQUEST['friend']))
				{
					sesaame_error(SESAAME_ERROR_ALREADY_MEMBER);
					sesaame_form_invite();
				}
				else
				{
					sesaame_send_invite_email(sesaame_new_invite());
					sesaame_greeting(SESAAME_SUCCESS_INVITE);
					sesaame_form_invite();
				}
			}
		}
	}

	function sesaame_join()
	{
		if(!sesaame_valid_email($_REQUEST['email']))
		{
			sesaame_error(SESAAME_ERROR_INVALID_EMAIL);
			sesaame_form_join();
		}
		else
		{
			if(sesaame_listed($_REQUEST['email']))
			{
				sesaame_error(SESAAME_ERROR_ALREADY_MEMBER);
				sesaame_form_join();
			}
			else
			{
				if(SESAAME_REQUIRE_VERIFICATION)
				{
					$_REQUEST['friend'] = $_REQUEST['email'];
					$_REQUEST['email'] = '(none)';
					sesaame_send_verification_email(sesaame_new_invite());
					sesaame_greeting(SESAAME_SUCCESS_SIGNUP);
				}
				else
				{
					sesaame_new_member();
					sesaame_greeting(SESAAME_SUCCESS_JOIN);
				}
			}
		}
	}

// Main

	function sesaame()
	{
		if(!empty($_REQUEST['action']))
			$_REQUEST['action'] = strtolower($_REQUEST['action']);
		else $_REQUEST['action'] = '';

		print "<div id=\"sesaame\">\n";
		switch($_REQUEST['action'])
		{
			case 'join':

				if(empty($_REQUEST['email']))
				{
					sesaame_greeting(SESAAME_GREETING_JOIN);
					sesaame_form_join();
				}
				else
				{
					$_REQUEST['email'] = trim($_REQUEST['email']);
					sesaame_join();
				}
				break;

			case 'verify':

				if(empty($_REQUEST['id']))
				{
					sesaame_greeting(SESAAME_GREETING_JOIN);
					sesaame_form_join();
				}
				else
				{
					$_REQUEST['id'] = trim($_REQUEST['id']);
					sesaame_verify();
				}
				break;

			case 'invite':

				if(empty($_REQUEST['email']) || empty($_REQUEST['friend']))
				{
					sesaame_greeting(SESAAME_GREETING_INVITE);
					sesaame_form_invite();
				}
				else
				{
					$_REQUEST['email'] = trim($_REQUEST['email']);
					$_REQUEST['friend'] = trim($_REQUEST['friend']);
					sesaame_invite();
				}
				break;

			case 'info':

				if(empty($_REQUEST['email']))
				{
					sesaame_greeting(SESAAME_GREETING_INFO);
					sesaame_form_info();
					print '<a id="sesaame_link_remove" href="?action=remove">Unsubscribe</a>';
				}
				else
				{
					$_REQUEST['email'] = trim($_REQUEST['email']);
					$refs = sesaame_refs($_REQUEST['email']);
					sesaame_greeting(str_replace('%refs%',$refs,SESAAME_GREETING_REFS));
				}
				break;

			case 'remove':

				if(empty($_REQUEST['email']))
				{
					sesaame_greeting(SESAAME_GREETING_REMOVE);
					sesaame_form_remove();
				}
				else
				{
					$_REQUEST['email'] = trim($_REQUEST['email']);
					sesaame_remove($_REQUEST['email']);
				}
				break;

			default:

				sesaame_greeting(SESAAME_GREETING_HOME);
			
		}
		sesaame_nav();
		print "</div>\n";
	}

?>